# std::is_enum

From cppreference.com
< cpp‎ | types

Defined in header `<type_traits>` |  |
template< class T > struct is_enum; |  | (since C++11)

Checks whether `T` is an enumeration type. Provides the member constant `value` which is equal to true, if `T` is an enumeration type . Otherwise, `value` is equal to false.

### Template parameters

T | - | a type to check

### Helper variable template

template< class T > inline constexpr bool is_enum_v = is_enum<T>::value; |  | (since C++17)

## Inherited from std::integral_constant

### Member constants

value [static] | true if `T` is an enumeration type , false otherwise (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant <bool, value>

### Example

Run this code

    #include <iostream>
    #include <type_traits>

    class A {};

    enum E {};

    enum class Ec : int {};

    int main()
    {
        std::cout << std::boolalpha;
        std::cout << std::is_enum<A>::value << '\n';
        std::cout << std::is_enum<E>::value << '\n';
        std::cout << std::is_enum<Ec>::value << '\n';
        std::cout << std::is_enum<int>::value << '\n';
    }

Output:

    false
    true
    true
    false

### See also

is_integral (C++11) | checks if a type is an integral type (class template)
is_arithmetic (C++11) | checks if a type is an arithmetic type (class template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/types/is_enum&oldid=97248"